; Copyright (c) 1991, Louis Marienthal, All Rights Reserved

      ;    1  descctrl                              ---
      ;    2  DescDir                               A28
      ;    3  ProcDir                               A28
      ;    4  LibDir                                A28
      ;    5  SpecDir                               A28
      ;    6  WorkDir                               A28
      ;    7  Table                                 A28
      ;    8  Form                                  A2
      ;    9  Spec                                  A6
      ;   10  Ctrl.f                                A1
      ;   11  Script                                A8
      ;   12  AutoE.f                               A1

;===
PROC UK_Init ()
    ;==========
PRIVATE
fmax.n,;   number of positions (fields)
fld.r,;    array [fmax.n] of field names
beg.r,;    array [fmax.n] of beginning column numbers of fields - commented out
end.r,;    array [fmax.n] of ending column numbers of fields - commented out
row.r,;    array [fmax.n] of row numbers of fields - commented out
group.s,;  string of length fmax.n: "S" = group
path.s,;   string of length fmax.n: Asc("S") = path.r[x-64]
luh.s,;    string of length fmax.n: y = LookupHelp available
prep.s,;   string of length fmax.n: y = pre field process
pstp.s,;   string of length fmax.n: y = post field process
rqd.s,;    string of length fmax.n: y = required
tab.s,;    string of length fmax.n: y = tab stop
right.s,;  string of length fmax.n: Asc("S") = fld.r[x-64]
left.s,;   string of length fmax.n: Asc("S") = fld.r[x-64]
down.s,;   string of length fmax.n: Asc("S") = fld.r[x-64]
up.s,;     string of length fmax.n: Asc("S") = fld.r[x-64]
mask.s,;   string of length fmax.n: Asc("S") = mask.r[x-64]
mask.r,;   array [m] of masks of legal function keys
mask.a,;   current mask
pmax.n,;   number of pathnames (tables)
path.r,;   array [pmax.n] of pathnames
plink.s,;  string of length pmax.n: "S" = linktype abreviation
pkeys.n,;  keys in current path
tkeys.n,;  number of keys in tablnam.a
path.a,;   current path alfa character
path_a,;   presumed new path alfa character
pathnam.a,;current pathname
tablnam.a,;path of master table with form
form.a,;   master form of tablnam.a
gmax.n,;   number of groups
gmax.r,;   array [gmax.n] of last pos_n in group
gmin.r,;   array [gmax.n] of first pos_n in group
pmax.r,;   array [pmax.n] of last pos_n in path
pmin.r,;   array [pmax.n] of first pos_n in path
px34.r,;   array [pmax.n] of pos_n where F3/F4 should return to
msg.a,;    active message to be displayed by UK_Msg
save.x,;   current saved field value
pos.n,;    current position num
pos_n,;    presumed new position num
grp.n,;    current group num
grp_n,;    presumed new group num
minus.s,;  string of length 133: types of negative keycodes
plus.s,;   string of length 255: types of positive keycodes
edit.f,;   flag if Edit Mode; not edit.f => View Mode
a1.f,;     flag if current field is type A1
disp.f,;   flag if path.a is DisplayOnly
kctrl.f,;  flag to switch Home/End PgUp/PgDn with Control variants
autoe.f,;  flag if automatic enter for ditto, A1 fields, field-view exit
new.f,;    flag if current record was new
quit.f,;   flag for End-of-Job
linkg.f,;  flag if path.a is field linked
linkm.f,;  flag if path.a is key linked 1-M
linko.f,;  flag if path.a is key linked 1-1
linku.f,;  flag if path.a is unlinked
mastl.f,;  flag if path.a = tablnam.a and multirecord
mastx.f,;  flag if path.a = tablnam.a and not multirecord
mult.f,;   flag if linkm.f or linku.f: i.e., functionly embedded multirecord
p.r,;      array [8] of prompt segments
ph1.a,;    help prompt line 1
ph2.a,;    help prompt line 2
pmt1.a,;   current 1st prompt
pmt2.a,;   current 2nd prompt
pw1a.a,;   "EDIT MODE   "
pw1b.a,;   "VIEW MODE   "
pw2a.a,;   "Display Only   "
pw3a.a,;   "Master "
pw3b.a,;   "Embedded "
pw4a.a,;   "Unit Form   "
pw4b.a,;   "MultiRecord Form   "
pw5a.a,;   "Key Linked 1 to Many"
pw5b.a,;   "Key Linked 1 to 1"
pw5c.a,;   "Field Linked"
pw5d.a,;   "Unlinked"
pw6a.a,;   "Must-Stay-in-Record   "
pw6b.a,;   "OK-To-Move-Off-Record   "
pw6c.a,;   "No-Record-Scrolling   "
pw6d.a,;   "Record-Scrolling-OK   "
pw7a.a,;   "F2:OK/File   "
pw7b.a,;   "F5:Set-View-Mode   F10:End-of-Job   "
pw7c.a,;   "F9:Change-This-Record  Alt-F9:Enter-New-Record   "
pw8a.a,;   "F1:LookupHelp"
uk.bor.f,; flag to execute KAS_BOR from UK_Field
uk.prep.f; flag to execute KAS_Prep_ from UK_Field (if prep spec = "y")

Reset
READLIB descctrl.r [2] + "desc123" UK_Err
errorproc = "UK_Err"
Play descctrl.r [5] + descctrl.r [9] + "_v"

;          1234567890123456789012345678901
plus.s  = "XXXFXFXKmXXXFXXXXXXXFXXXXFFXXXX"
;         +32 thru 127: "K"  +128 thru 255: "X"

;             0 to 14    15   16        34    35       44
minus.s = Fill("X",15) + "m" + Fill("X",19) + "FXXXXXXXXF"
;        45        58    59       68
        + Fill("X",14) + "FFFFFXXFFF"
;          90123456789012   83       103    45678901234567890123456789012
        + "XXqmqXmXmXqmqM" + Fill("F",21)+ "FXXXFXXXFXXmmqqqXXXXXXXXXXXXq"

IF descctrl.r [11] = "" THEN      ; no ap-specific script; turn off
   pstp.s = fill ("n", fmax.n)    ; processing that might be
   prep.s = fill ("n", fmax.n)    ; defined in spec table and script
   mask.s = fill ("A", fmax.n)    ; turn off Ctrl-F and Shft-F keys
   mask.r [1] = fill ("n", 20)    ; that may be defined
ELSE
   AutoLib = descctrl.r [4] + descctrl.r [11] + "," + AutoLib
ENDIF

UK_ClearBuf ()
RetVal = true                ; initialize retval
KAS_BOJ ()                   ; do whatever unique to startup
IF Not RetVal THEN
   Return false
ENDIF

View tablnam.a
RequiredCheck Off
CoEditKey
PickForm form.a
IF Not IsEmpty (tablnam.a) THEN
   msg.a = "View Mode: First Master Record"
   edit.f = false
   view.f = true
ELSE
   edit.f = true
   view.f = false
   new.f = true
ENDIF

uk.bor.f = true
uk.prep.f = true
pos.n = 0                    ; force NewTop to work
grp.a = "Z"
path.a = "z"

UK_NewTop ()
UK_Main ()

RequiredCheck On
Reset

ENDPROC
;======

;===
PROC UK_UMF8 ()
    ;==========

SWITCH
   Case RecordStatus ("New") and Not RecordStatus ("Modified"):
      Beep
      msg.a = "Nothing to Clear or Delete"
   Case Not RecordStatus ("New"):   ; deletes linked forms if any
      UK_Delete ()                  ; may return edit.f = false
   Case RecordStatus ("New") and RecordStatus ("Modified"):
      Beep                          ; ed -- not yet moved off master
      Del
      IF Not IsFormView () THEN     ; deleted first and only record
         PickForm form.a            ; not multiform
      ELSE
         CtrlEnd
         Enter
         new.f = true
      ENDIF
ENDSWITCH

ENDPROC
;======

;===
PROC UK_Delete ()
    ;============
Private p, xpath.a, dm.a, only.f, lt.a

xpath.a = " "
FOR p FROM pmax.n TO 1 STEP -1
   IF path.r [p] = xpath.a THEN
      Loop                          ; loop if consecutive groups
   ENDIF                            ; have same path
   xpath.a = path.r [p]
   MoveTo xpath.a
   lt.a = SubStr (plink.s, p, 1)
   IF lt.a = "M" THEN
      WHILE Not RecordStatus ("New")
         Del
      ENDWHILE
      Loop
   ENDIF
   IF lt.a = "O" and Not RecordStatus ("New") THEN
      Del
      Loop
   ENDIF
   IF xpath.a = tablnam.a THEN      ; master record
      IF Not new.f THEN             ; was modifying old record
         edit.f = false             ; accessed from View
         view.f = true              ; put back into View
      ENDIF
      IF Not edit.f THEN
         only.f = false
         dm.a = "Next"
         IF AtLast () THEN
            dm.a = "Prior (Last)"
            IF AtFirst () THEN
               only.f = true
            ENDIF
         ENDIF
         Beep
         Del
         IF only.f THEN
            IF Not IsFormView () THEN  ; deleted first and only
               PickForm form.a         ; not multiform
            ENDIF
            new.f = true
            edit.f = true
            view.f = false
            msg.a = "One and Only Record Deleted: Edit Mode"
            QuitLoop
         ELSE
            KAS_GetForm ()             ; maybe new form type
         ENDIF
         msg.a = "Record Deleted: Viewing " + dm.a + " Record"
         QuitLoop
      ELSE                             ; ed and new.f
         Beep
         Del
         End
         CtrlEnd                       ; maybe moved away from last
         Enter                         ; record by lookup
         QuitLoop
      ENDIF
   ENDIF
ENDFOR

ENDPROC
;======

;===
PROC UK_DelOK ()
    ;============
Private x

    @18,33 ?? "ͻ"
    @19,33 ?? "                                "
    @20,33 ?? "        Are You Sure ?          "
    @21,33 ?? "  To Reconfirm, Press F8 Again  "
    @22,33 ?? "   Otherwise, Press Space Bar   "
    @23,33 ?? "                                "
    @24,33 ?? "ͼ"

UK_ClearBuf ()
WHILE true
   IF CharWaiting () THEN
      x = GetChar ()
      SWITCH
         Case x = 32:  msg.a = "Delete Cancelled"
                       Return false    ; space = no go
         Case x = -66: Return true     ; F8 = confirm
         Otherwise:    Beep            ; otherwise loop
      ENDSWITCH
   ENDIF
ENDWHILE

ENDPROC
;======

;===
PROC UK_Left ()
    ;==========
Private pos_a

pos_a = SubStr (left.s, pos.n, 1)
IF pos_a <> "@" THEN
   pos_n = Asc (pos_a) - 64
ELSE
   Beep
ENDIF

ENDPROC
;======

;===
PROC UK_Right ()
    ;===========
Private pos_a

pos_a = SubStr (right.s, pos.n, 1)
IF pos_a <> "@" THEN
   pos_n = Asc (pos_a) - 64
ELSE
   Beep
ENDIF

ENDPROC
;======

;===
PROC UK_Up ()
    ;========
Private pos_a

pos_a = SubStr (up.s, pos.n, 1)
UK_UpDn (270)

ENDPROC
;======

;===
PROC UK_Down ()
    ;==========
Private pos_a

pos_a = SubStr (down.s, pos.n, 1)
UK_UpDn (271)

ENDPROC
;======

;===
PROC UK_UpDn (kc.n)
    ;==============

SWITCH
   Case pos_a = "@": Beep
   Case pos_a = "?": IF mult.f THEN
                        kchr = kc.n
                        ktyp = "M"
                        UK_MoveL ()
                     ENDIF
   Otherwise:        pos_n = Asc (pos_a) - 64
ENDSWITCH

ENDPROC
;======

;===
PROC UK_Tab ()
    ;=========
Private x

FOR x FROM pos.n + 1 TO fmax.n
   IF SubStr (tab.s, x, 1) = "y" THEN              ; this is tab stop
      IF SubStr (path.s, x, 1) = path.a THEN       ; this same path
         pos_n = x
         QuitLoop
      ENDIF
   ENDIF
ENDFOR
IF x > fmax.n THEN
   Beep
ENDIF

ENDPROC
;======

;===
PROC UK_RevTab ()
    ;=========
Private x

FOR x FROM pos.n - 1 TO 1 Step -1
   IF SubStr (tab.s, x, 1) = "y" THEN              ; this is tab stop
      IF SubStr (path.s, x, 1) = path.a THEN       ; this same path
         pos_n = x
         QuitLoop
      ENDIF
   ENDIF
ENDFOR
IF x < 1 THEN
   Beep
ENDIF

ENDPROC
;======

;===
PROC UK_CtrlKey ()
    ;=============

SWITCH
   Case kctrl.f and kchr = -71:   kchr = 260  ; Home     = MinPos
                                  ktyp = "m"
   Case kctrl.f and kchr = -79:   kchr = 261  ; End      = MaxPos
                                  ktyp = "m"
   Case kctrl.f and kchr = -119:  kchr = 262  ; CtrlHome = MinRec
   Case kctrl.f and kchr = -117:  kchr = 263  ; CtrlEnd  = MaxRec
   Case kctrl.f and kchr = -73:   kchr = 270  ; PgUp     = RecUp
   Case kctrl.f and kchr = -81:   kchr = 271  ; PgDn     = RecDn
   Case kctrl.f and kchr = -132:  kchr = 272  ; CtrlPgUp = ScrlUp
   Case kctrl.f and kchr = -118:  kchr = 273  ; CtrlPgDn = ScrlDn
   Case kchr = -71:   kchr = 262            ; Home     = MinRec
   Case kchr = -79:   kchr = 263            ; End      = MaxRec
   Case kchr = -119:  kchr = 260            ; CtrlHome = MinPos
                      ktyp = "m"
   Case kchr = -117:  kchr = 261            ; CtrlEnd  = MaxPos
                      ktyp = "m"
   Case kchr = -73:   kchr = 272            ; PgUp     = ScrlUp
   Case kchr = -81:   kchr = 273            ; PgDn     = ScrlDn
   Case kchr = -132:  kchr = 270            ; CtrlPgUp = RecUp
   Case kchr = -118:  kchr = 271            ; CtrlPgDn = RecDn
ENDSWITCH
IF ktyp <> "m" THEN           ; "m" is intra-record move
   ktyp = "M"                 ; "M" is inter-record move
ENDIF

ENDPROC
;======

;===
PROC UK_Err ()
    ;=========
Private errorproc

IF ErrorCode () = 56 or ErrorCode () = 53 THEN
   Return 1                               ; error goes to next line
ELSE
   Message "DESC Error -- Directory Is " + Directory ()
   Return 2                               ; error calls debugger
ENDIF

ENDPROC
;======

;===
PROC UK_ClearBuf ()
    ;==============
Private b

WHILE CharWaiting ()        ; empty keyboard buffer
   b = GetChar ()
ENDWHILE

ENDPROC
;======

;===
PROC UK_UnDo ()
    ;==========

ImageRights                 ; want to reverse delete from vu mode
{UnDo} {Yes}
UK_NewTop ()
Beep
IF Not edit.f THEN
   ImageRights ReadOnly
ENDIF

ENDPROC
;======

;===
PROC UK_FV ()              ; reading keyboard in Field View
    ;========

WHILE IsFieldView ()
   SWITCH
      Case ktyp = "K": ; number or letter or etc.
         SWITCH
             Case disp.f:        Beep
                                 msg.a = "Form Is Display Only"
             Case Not edit.f:    Beep
                                 msg.a = "Cannot Change Field in View Mode"
             Otherwise:          KeyPress kchr
         ENDSWITCH
      Case ktyp = "M"
        or ktyp = "m": ; FieldView: Left, Right, Home, End, Ins
         SWITCH
             Case kchr = -75 or kchr = -77 or
                  kchr = -115 or kchr = -116 or
                  kchr = -82:               KeyPress kchr
             Case kchr = 260 or kchr = 262: Home
             Case kchr = 261 or kchr = 263: End
             Otherwise:    msg.a = "To Leave FieldView, Press Enter"
         ENDSWITCH
      Case ktyp = "F": ; FieldView: Enter
                        SWITCH
                           Case kchr = -83:    ; Delete
                              KeyPress kchr
                           Case kchr = 13:     ; Enter
                              KeyPress kchr
                              QuitLoop
                           Case kchr = -108    ; Alt-F5 or Ctrl-F
                             or kchr = 6:      ; kchr when called: Loop
                           Otherwise:
                              msg.a = "To Leave FieldView, Press Enter"
                        ENDSWITCH
      Otherwise:        Beep                   ; ktyp = X
   ENDSWITCH

   UK_KB ()
ENDWHILE

IF edit.f and not disp.f and autoe.f THEN
   UK_Enter ()                                 ; do what enter would do
ENDIF

ENDPROC
;======

;===
PROC UK_Ditto ()
    ;===========

IF Not edit.f THEN
   Beep
   Return
ENDIF
IF disp.f THEN
   msg.a = "Form Is Display Only"
   Return
ENDIF
IF Not AtFirst () THEN
   CtrlBackSpace
   Ditto
   IF autoe.f THEN
      UK_Enter ()                    ; if Ditto loads field, do what
   ENDIF                             ; regular ENTER would do
ELSE
   Beep
   msg.a = "First Record -- Nothing to Ditto"
ENDIF

ENDPROC
;======

;===
PROC UK_Zoomer ()
    ;============

IF edit.f and HelpMode () = "None" THEN
   IF mastx.f or linko.f THEN
      msg.a = "In Edit Mode, Can't Zoom Off Master or Form Linked 1-1"
      Return
   ENDIF
ENDIF
UK_FldChk ()
IF Not RetVal THEN
   Return
ENDIF
UK_RecChk (false)
IF Not RetVal THEN
   Return
ENDIF
IF ColNo () = 1 THEN                 ; For L/U-Help, but shouldn't happen
   Beep
   msg.a = "Can't Zoom on Record Number"
   Return
ENDIF
IF NImageRecords () < 2 THEN
   Beep
   msg.a = "This Is One and Only Record"
   Return
ENDIF
IF kchr = 26 THEN
   UK_Zoom ()
ELSE
   UK_ZoomDo (-44)
ENDIF

ENDPROC
;======

;===
PROC UK_Zoom ()
    ;==========
Private kchr

Echo Normal
Zoom
"x"                                  ; make sure that 'Value:' not blank
CtrlBackSpace
WHILE true
   UK_KB ()
   Echo Normal
   IF Not IsFieldView () THEN
      SWITCH
         Case ktyp = "K"     ; number or letter or etc.
           or kchr = -108    ; Alt-F5
           or kchr = 6:      ; Ctrl-F
            KeyPress kchr    ; Field View
         Case kchr = 13:     ; Enter
            Echo Off
            UK_ZoomDo (13)
            IF RetVal THEN
               QuitLoop
            ENDIF
            Echo Normal
            Zoom
         Case kchr = 27:     ; Esc
            Echo Off
            CtrlBackSpace
            KeyPress kchr
            QuitLoop
         Otherwise:          Beep
      ENDSWITCH
   ELSE
      UK_FV ()
   ENDIF
ENDWHILE

ENDPROC
;======

;===
PROC UK_ZoomDo (x)
    ;=============

KeyPress x
msg.a = Window ()
IF IsBlank (msg.a) THEN
   save.x = []
   msg.a = "Found Record Number " + StrVal (RecNo ())
   KAS_BOR ()
   Return true
ENDIF
Return false

ENDPROC
;======

;===
PROC UK_SelHelp ()
    ;=============
Private ht.a, hup.a, hdn.a, hpanel.f, htitle.a,
        hstyle.a, hlines.n, hline1.n, hline2.n,
        hrow, kchr, todo

kchr  = 65            ; initial kchr
UK_ClearBuf ()
Cursor Off

Clear
@ 0,0 ?? "Esc: Return to Data Entry    Home: Table of Contents    End: Index"
@ 1,0 ?? "Letter: Select Help Topic    PgUp/PgDn: Scan Through Help Pages"
PaintCanvas Attribute 63 0,0,1,79

WHILE true
   SWITCH
      Case kchr >= 65
       and kchr <= 90:  ht.a = Chr (kchr)
      Case kchr >= 97
       and kchr <= 122: ht.a = Chr (kchr - 32)
      Case kchr = -71:  ht.a = "A"    ; Home
      Case kchr = -79:  ht.a = "W"    ; End
      Case kchr = -73:  ht.a = hup.a  ; PgUp
      Case kchr = -81:  ht.a = hdn.a  ; PgDn
      Case kchr = 27:   QuitLoop      ; Esc
      Otherwise:        Beep          ; bad key
   ENDSWITCH

   UK_ShowHelp ()

   kchr = GetChar ()
ENDWHILE

ENDPROC
;======

;===
PROC UK_ShowHelp ()
    ;==============

Canvas Off
@ 2,0 Clear EOS
@ 5,0
todo = "UK_Text" + ht.a
ExecProc todo
IF hstyle.a = "W" and Not kctrl.f THEN
   @ 2,0 Clear EOS
   @ 5,0
   todo = "UK_Text" + ht.a + "P"
   ExecProc todo
ENDIF
IF hstyle.a = "X" and Not autoe.f THEN
   @ 2,0 Clear EOS
   @ 5,0
   todo = "UK_Text" + ht.a + "X"
   ExecProc todo
ENDIF
@ 3,0  ?? Format ("w80,ac", SubStr (ht.a,1,1) + ". " + htitle.a)
PaintCanvas Attribute 31 2,0,24,79
IF hpanel.f THEN
   PaintCanvas Attribute 63 5,13,4+hlines.n,73
ELSE
   PaintCanvas Attribute 63 5,11,4+hline1.n,41
   PaintCanvas Attribute 63 5,46,4+hline2.n,76
ENDIF
Canvas On

ENDPROC
;======

;===
PROC UK_PathPmpt ()
    ;==============
Private lt.a, todo

disp.f = false
mastl.f = false
mastx.f = false
linko.f = false
linkm.f = false
linkg.f = false
linku.f = false
mult.f = false

p.r [2] = ""
IF FormType ("DisplayOnly") THEN
   disp.f = true
   p.r [2] = pw2a.a              ; Display Only
ENDIF

lt.a = SubStr (plink.s, path.n, 1)
SWITCH
   Case lt.a = "X":
      mastx.f = true
      p.r[3] = pw3a.a + pw4a.a   ; master unit
      p.r[5] = ""
   Case lt.a = "L":
      mastl.f = true
      p.r[3] = pw3a.a + pw4b.a   ; master multirecord
      p.r[5] = ""
      p.r[6] = pw6b.a            ; Record-Scrolling-OK
   Case lt.a = "M":
      linkm.f = true
      mult.f = true
      p.r[3] = pw3b.a            ; Embedded
      p.r[5] = pw5a.a            ; Key Linked 1 to Many
      p.r[6] = pw6b.a            ; Record-Scrolling-OK
   Case lt.a = "O":
      linko.f = true
      p.r[3] = pw3b.a            ; Embedded
      p.r[5] = pw5b.a            ; Key Linked 1 to 1
      p.r[6] = pw6a.a            ; No-Record-Scrolling
   Case lt.a = "G":
      linkg.f = true
      p.r[3] = pw3b.a            ; Embedded
      p.r[5] = pw5c.a            ; Field Linked
      p.r[6] = pw6a.a            ; No-Record-Scrolling
   Case lt.a = "U":
      linku.f = true
      mult.f = true
      p.r[3] = pw3b.a            ; Embedded
      p.r[5] = pw5d.a            ; Unlinked
      p.r[6] = pw6b.a            ; Record-Scrolling-OK
ENDSWITCH

ENDPROC
;======

;===
PROC UK_FldPmpt ()
    ;=============

a1.f = false
IF FieldType () = "A1" THEN
   a1.f = true
ENDIF
                                 ; set up mask of legal F-keys
mask.a = mask.r [Asc (SubStr (mask.s, pos.n, 1)) - 64]

IF edit.f THEN
   p.r[1] = pw1a.a               ; EDIT MODE
   IF (mastx.f or mastl.f) and RecordStatus ("New")
      and Not RecordStatus ("Modified") THEN
      p.r[7] = pw7b.a            ; F5:View-Mode   F10:End-of-Job
   ELSE
      p.r[7] = pw7a.a            ; F2:OK/File
   ENDIF
   IF mastx.f THEN
      p.r[6] = pw6a.a            ; No-Record-Scrolling
   ENDIF
ENDIF
IF view.f THEN
   p.r[1] = pw1b.a               ; VIEW MODE
   p.r[7] = pw7c.a               ; F9:Change-This-Record -- etc.
   IF mastx.f THEN
      p.r[6] = pw6b.a            ; Record-Scrolling-OK
   ENDIF
ENDIF
p.r[8] = ""
IF SubStr (luh.s, pos.n, 1) = "y" THEN
   p.r[8] = pw8a.a               ; F1:LookupHelp
ENDIF

pmt1.a = p.r[1] + p.r[2] + p.r[3] + p.r[5] + p.r[6]
pmt2.a = p.r[7] + p.r[8]

IF uk.prep.f and SubStr (prep.s, pos.n, 1) = "y" THEN
   todo = "KAS_Prep_" + StrVal (pos.n)
   ExecProc todo                        ; redefine prompts ??
ELSE
   uk.prep.f = true
ENDIF

Prompt pmt1.a, pmt2.a

ENDPROC
;======

; null procs in case there is no application-specific script

Proc KAS_BOJ ()     EndProc
Proc KAS_EOJ ()     EndProc
Proc KAS_BOR ()     EndProc
Proc KAS_EOR ()     EndProc
Proc KAS_DelR ()    EndProc
Proc KAS_GetForm () EndProc
