; Copyright (c) 1991, Louis Marienthal, All Rights Reserved

      ;    1  descctrl                              ---
      ;    2  DescDir                               A28
      ;    3  ProcDir                               A28
      ;    4  LibDir                                A28
      ;    5  SpecDir                               A28
      ;    6  WorkDir                               A28
      ;    7  Table                                 A28
      ;    8  Form                                  A2
      ;    9  Spec                                  A6
      ;   10  Ctrl.f                                A1
      ;   11  Script                                A8
      ;   12  AutoE.f                               A1

;===
PROC UK_DoVars ()
    ;============
PRIVATE
fmax.n,;   number of positions (fields)
fld.r,;    array [fmax.n] of field names
beg.r,;    array [fmax.n] of beginning column numbers of fields - commented out
end.r,;    array [fmax.n] of ending column numbers of fields - commented out
row.r,;    array [fmax.n] of row numbers of fields - commented out
group.s,;  string of length fmax.n: "S" = group
path.s,;   string of length fmax.n: Asc("S") = path.r[x-64]
luh.s,;    string of length fmax.n: y = LookupHelp available
prep.s,;   string of length fmax.n: y = pre field process
pstp.s,;   string of length fmax.n: y = post field process
rqd.s,;    string of length fmax.n: y = required
tab.s,;    string of length fmax.n: y = tab stop
right.s,;  string of length fmax.n: Asc("S") = fld.r[x-64]
left.s,;   string of length fmax.n: Asc("S") = fld.r[x-64]
down.s,;   string of length fmax.n: Asc("S") = fld.r[x-64]
up.s,;     string of length fmax.n: Asc("S") = fld.r[x-64]
mask.s,;   string of length fmax.n: Asc("S") = mask.r[x-64]
mask.r,;   array [m] of masks of legal function keys
mask.a,;   current mask
pmax.n,;   number of pathnames (tables)
path.r,;   array [pmax.n] of pathnames
plink.s,;  string of length pmax.n: "S" = linktype abreviation
pkeys.n,;  keys in current path
tkeys.n,;  number of keys in tablnam.a
path.a,;   current path alfa character
path_a,;   presumed new path alfa character
pathnam.a,;current pathname
tablnam.a,;path of master table with form
form.a,;   master form of tablnam.a
gmax.n,;   number of groups
gmax.r,;   array [gmax.n] of last pos_n in group
gmin.r,;   array [gmax.n] of first pos_n in group
pmin.r,;   array [pmax.n] of first pos_n in path
pmax.r,;   array [pmax.n] of last pos_n in path
px34.r,;   array [pmax.n] of pos_n where F3/F4 should return to
msg.a,;    active message to be displayed by UK_Msg
save.x,;   current saved field value
pos.n,;    current position num
pos_n,;    presumed new position num
grp.n,;    current group num
grp_n,;    presumed new group num
minus.s,;  string of length 133: types of negative keycodes
plus.s,;   string of length 255: types of positive keycodes
edit.f,;   flag if Edit Mode; not edit.f => View Mode
a1.f,;     flag if current field is type A1
disp.f,;   flag if path.a is DisplayOnly
kctrl.f,;  flag to switch Home/End PgUp/PgDn with Control variants
new.f,;    flag if current record was new
quit.f,;   flag for End-of-Job
linkg.f,;  flag if path.a is field linked
linkm.f,;  flag if path.a is key linked 1-M
linko.f,;  flag if path.a is key linked 1-1
linku.f,;  flag if path.a is unlinked
mastl.f,;  flag if path.a = tablnam.a and multirecord
mastx.f,;  flag if path.a = tablnam.a and not multirecord
mult.f,;   flag if linkm.f or linku.f: i.e., functionly embedded multirecord
mrec.f,;   flag if multirecord form
p.r,;      array [8] of prompt segments
ph1.a,;    help prompt line 1
ph2.a,;    help prompt line 2
pmt1.a,;   current 1st prompt
pmt2.a,;   current 2nd prompt
pw1a.a,;   "EDIT MODE   "
pw1b.a,;   "VIEW MODE   "
pw2a.a,;   "Display Only   "
pw3a.a,;   "Master "
pw3b.a,;   "Embedded "
pw4a.a,;   "Unit Form   "
pw4b.a,;   "MultiRecord Form   "
pw5a.a,;   "Key Linked 1 to Many"
pw5b.a,;   "Key Linked 1 to 1"
pw5c.a,;   "Field Linked"
pw5d.a,;   "Unlinked"
pw6a.a,;   "Must-Stay-in-Record   "
pw6b.a,;   "OK-To-Move-Off-Record   "
pw6c.a,;   "No-Record-Scrolling   "
pw6d.a,;   "Record-Scrolling-OK   "
pw7a.a,;   "F2:OK/File   "
pw7b.a,;   "F5:Set-View-Mode   F10:End-of-Job   "
pw7c.a,;   "F9:Change-This-Record  Alt-F9:Enter-New-Record   "
pw8a.a;    "F1:LookupHelp"

Reset
READLIB descctrl.r [2] + "desc45" UK_Err
ErrorProc = "UK_Err"
UK_GetCtrl ("3")
IF Not RetVal THEN
   Reset
   Return
ENDIF

spectabl.a = descctrl.r [5] + descctrl.r [9]
IF Not IsTable (spectabl.a) THEN
   Beep
   Message spectabl.a + " Specification Table Not Found" Sleep 2000
   Reset
   Return
ENDIF

UK_PosChk ()
IF Not RetVal THEN
   Reset
   Return
ENDIF

IF descctrl.r [10] = "P" THEN
   kctrl.f = false
ELSE
   kctrl.f = true
ENDIF

IF descctrl.r [12] = "Y" THEN
   autoe.f = true
ELSE
   autoe.f = false
ENDIF

Cursor Off
wrktabl.a = descctrl.r [2] + "fields"
homedir.a = Directory ()
SetDir descctrl.r [6]

UK_BaseVars ()
UK_Groups ()
UK_Masks ()
UK_Arrows ()
UK_SaveV ()
UK_SpecRpt ()
Empty wrktabl.a

IF SubStr (Directory (), 2, 1) = ":" THEN
   SetDir SubStr (Directory (), 1, 2) + "\\"
ENDIF
SetDir homedir.a

WHILE CharWaiting ()
   x = GetChar ()
ENDWHILE

@ 12,1 ?? Format ("w80,ac", "Specification Stored As Script " + outsc.a)
@ 15,1 ?? Format ("w80,ac", "(Press Space Bar To Clear)")

WHILE true
   IF CharWaiting () THEN
      x = GetChar ()
      IF x = 32 THEN
         QuitLoop
      ENDIF
   ENDIF
ENDWHILE
Reset

EndProc
;======

;===
PROC UK_BaseVars ()
    ;==============
Private calc1, calc2, ng.r, ngf.r, x, y

@ 4,20 ?? "Creating Work Table"

ClearAll
View spectabl.a
tablnam.a = [Pathname]
form.a = [Form]
tkeys.n = NKeyFields (tablnam.a)

Empty wrktabl.a
ClearAll
{Ask} Select spectabl.a Check
   [Pos] = "not blank"
   DO_IT!
Add "answer" wrktabl.a
Sort wrktabl.a ON "Pos"

@ 6,20 ?? "Defining Basic Variables"
ClearAll
View wrktabl.a
fmax.n = NRecords (wrktabl.a)
Array fld.r [fmax.n]
Array kaxpath.r [fmax.n]          ; temporary

rqd.s  = ""
prep.s = ""
pstp.s = ""
luh.s = ""

SCAN
   n = [Pos]
   fld.r [n]  = [Field Name]
   kaxpath.r [n] = [Pathname]       ; temporary
   IF IsBlank ([Rqd]) THEN
      rqd.s = rqd.s + "n"
   ELSE
      rqd.s = rqd.s + "y"
   ENDIF
   IF IsBlank ([Pstp]) THEN
      pstp.s = pstp.s + "n"
   ELSE
      pstp.s = pstp.s + "y"
   ENDIF
   IF IsBlank ([Prep]) THEN
      prep.s = prep.s + "n"
   ELSE
      prep.s = prep.s + "y"
   ENDIF
   IF IsBlank ([LuH]) THEN
      luh.s = luh.s + "n"
   ELSE
      luh.s = luh.s + "y"
   ENDIF
ENDSCAN

ENDPROC
;======

;===
PROC UK_Groups ()
    ;============
Private p, t

@ 8,20 ?? "Defining Paths and Groups"

Array kaxpg.r [fmax.n]
ClearAll
View tablnam.a
PickForm form.a
FOR f FROM 1 to fmax.n
   IF kaxpath.r [f] = tablnam.a THEN
      MoveTo Field fld.r [f]
      kaxpg.r [f] = PageNo ()
   ELSE
      kaxpg.r [f] = 0
   ENDIF
ENDFOR
ClearAll

grp.n = 0
px.a = ""
pgx.a = ""
ClearAll
Edit wrktabl.a
SCAN
   p = [Pos]
   t = [Pathname]
   pg.a = StrVal (kaxpg.r [p])
   [Mask] = pg.a
   IF px.a <> t or pgx.a <> pg.a THEN
      px.a = t
      pgx.a = pg.a
      grp.n = grp.n + 1
      [Group] = CHR (grp.n + 64)              ; group is page or master
   ELSE                                       ; or embedded form
      [Group] = CHR (grp.n + 64)
   ENDIF
ENDSCAN
DO_IT!

ClearAll
{Ask} Select wrktabl.a
   MoveTo [Group] Check
   [Pos] = "calc min as MinPos, calc max as MaxPos"
   DO_IT!
gmax.n = NRecords ("answer")
Array gmax.r [gmax.n]
Array gmin.r [gmax.n]
SCAN
   n = ASC ([Group]) - 64
   gmax.r [n] = [MaxPos]
   gmin.r [n] = [MinPos]
ENDSCAN

ClearAll                               ; set tab stops at min or max
Edit wrktabl.a                         ; of each group
FOR x FROM 1 to gmax.n
   MoveTo Record gmax.r [x]
   [Tab] = "y"
   MoveTo Record gmin.r [x]
   [Tab] = "y"
ENDFOR
DO_IT!

ClearAll
{Ask} Select wrktabl.a
   MoveTo [Pathname] Check
   MoveTo [Path] Check
   [Pos] = "calc min as MinPos, calc max as MaxPos"
   DO_IT!
SORT "answer" ON "MinPos"
pmax.n = NRecords ("answer")
Array path.r [pmax.n]
Array pmin.r [pmax.n]
Array pmax.r [pmax.n]
Array px34.r [pmax.n]

Edit "answer"
SCAN
   n = RecNo ()
   [Path] = Chr (n + 96)
   path.r [n] = [Pathname]
   pmin.r [n] = [MinPos]
   pmax.r [n] = [MaxPos]
   px34.r [n] = [MinPos]
ENDSCAN
DO_IT!
path.a = "a"
path_a = "a"
pathnam.a = path.r [1]

ClearAll
{Ask} {answer}
   [Path] = "_a"
   [Pathname] = "_b"
{Ask} Select wrktabl.a
   [Path] = "changeto _a"
   [Pathname] = "_b"
DO_IT!

ClearAll
plink.s = ""
View tablnam.a
PickForm form.a
FOR x FROM 1 TO pmax.n
   MoveTo path.r [x]
   lt.a = LinkType ()
   SWITCH
      Case path.r [x] = tablnam.a and
         FormType ("MultiRecord"):     plink.s = plink.s + "L"
      Case path.r [x] = tablnam.a:     plink.s = plink.s + "X"
   ; => embedded
      Case Search ("1-M", lt.a) > 0:   plink.s = plink.s + "M"
      Case Search ("1-1", lt.a) > 0:   plink.s = plink.s + "O"
      Case Search ("Group", lt.a) > 0: plink.s = plink.s + "G"
      Otherwise:                       plink.s = plink.s + "U"
   ENDSWITCH
ENDFOR
ClearAll

ENDPROC
;======

;===
PROC UK_Masks ()
    ;===========
Private q, mp, m

@ 10,20 ?? "Defining Function-Key Masks"
ClearAll
Edit wrktabl.a
SCAN
   mp = ""
   MoveTo [SF1] Left
   FOR x FROM 1 TO 20
      Right
      IF IsBlank ([]) THEN
         mp = mp + "n"
      ELSE
         mp = mp + "y"
      ENDIF
   ENDFOR
   [MP] = mp
   [Mask] = ""
ENDSCAN
DO_IT!

ClearAll
{Ask} Select wrktabl.a
   MoveTo [Mask] Check
   MoveTo [MP] Check
DO_IT!

Array Mask.r [NRecords ("answer")]
ClearAll
Edit "answer"
SCAN
   x = RecNo ()
   [Mask] = Chr (x + 64)
   Mask.r [x] = [MP]
ENDSCAN
DO_IT!

ClearAll
{Ask} Select wrktabl.a
   [MP] = "_a"
   [Mask] = "Changeto _b"
{Ask} {answer}
   [MP] = "_a"
   [Mask] = "_b"
DO_IT!

ClearAll
View wrktabl.a
mask.s = ""
path.s = ""
group.s = ""
tab.s = ""
SCAN
   mask.s = mask.s + [Mask]
   path.s = path.s + [Path]
   group.s = group.s + [Group]
   IF IsBlank ([Tab]) THEN
      tab.s = tab.s + "n"
   ELSE
      tab.s = tab.s + "y"
   ENDIF
ENDSCAN
ClearAll

ENDPROC
;======

;===
PROC UK_Arrows ()
    ;============
Private f, p, tfld.a

Array right.r [fmax.n]
Array left.r [fmax.n]
Array down.r [fmax.n]
Array up.r [fmax.n]

Create "tscan" LIKE tablnam.a DO_IT!
ClearAll
Edit "tscan"
ft.a = FieldType ()
SWITCH
   Case ft.a = "N" or ft.a = "S" or ft.a = "$": [] = 1
   Case ft.a = "D": [] = Today ()
   Otherwise: [] = "A"
ENDSWITCH
DO_IT!
{Tools} {Copy} {Form} {DifferentTable}
   Select tablnam.a Select form.a {tscan} Select form.a

FOR x FROM 1 TO fmax.n
   IF kaxpath.r [x] = tablnam.a THEN
      kaxpath.r [x] = "tscan"
   ENDIF
ENDFOR

ClearAll
View "tscan"
PickForm form.a
RequiredCheck Off

tablx.a = ""
@ 12,20 ?? "Scanning Entry Form: Field "

FOR f FROM 1 TO fmax.n              ; go thru all the fields
   @ 12,47 ?? Format ("w3,al", f)
   IF tablx.a <> kaxpath.r [f] THEN
      tablx.a = kaxpath.r [f]
      MoveTo tablx.a
      path.n =  Asc (SubStr (path.s, f, 1)) - 96
      plink.a = SubStr (plink.s, path.n, 1)
   ENDIF

   grp.a = SubStr (group.s, f, 1)
   fld.a = fld.r [f]
   MoveTo Field fld.a

   right.r [f] = 0
   left.r [f] = 0
   right.f = false
   left.f = false
   down.f = false
   up.f = false
   IF plink.a = "X" or plink.a = "G" or plink.a = "O" THEN
      up.r [f] = 0
      down.r [f] = 0
   ELSE
      up.r [f] = -1                    ; different no-move signal
      down.r [f] = -1                  ; in multi-record forms
   ENDIF

   FOR p FROM 1 TO fmax.n
      IF p = f or SubStr (group.s, p, 1) <> grp.a THEN
         Loop                          ; base field or not same group
      ENDIF
      MoveTo Field fld.r [p]           ; move to eligible field
      tfld.a = Field ()                ; what field?

      MoveTo Field fld.a               ; move back to home base
      IF Not right.f THEN
         WHILE true
            fldy.a = Field ()
            Right                      ; move with key
            fldx.a = Field ()
            SWITCH
               Case tfld.a = fldx.a: right.r [f] = p   ; moved to match
                                     right.f = true
                                     QuitLoop
               Case fld.a = fldx.a:  right.f = true    ; didn't move from home
                                     QuitLoop
               Case fldx.a = fldy.a: QuitLoop          ; didn't move from move
               Otherwise:            UK_FldMatch ()
                                     IF RetVal THEN QuitLoop ENDIF
            ENDSWITCH
         ENDWHILE
      ENDIF

      MoveTo Field fld.a               ; move back to home base
      IF Not left.f THEN
         WHILE true
            fldy.a = Field ()
            Left                       ; move with key
            fldx.a = Field ()
            SWITCH
               Case tfld.a = fldx.a: left.r [f] = p   ; moved to match
                                     left.f = true
                                     QuitLoop
               Case fld.a = fldx.a:  left.f = true    ; didn't move from home
                                     QuitLoop
               Case fldx.a = fldy.a: QuitLoop         ; didn't move from move
               Otherwise:            UK_FldMatch ()
                                     IF RetVal THEN QuitLoop ENDIF
            ENDSWITCH
         ENDWHILE
      ENDIF

      MoveTo Field fld.a               ; move back to home base
      IF Not down.f THEN
         WHILE true
            fldy.a = Field ()
            Down                       ; move with key
            fldx.a = Field ()
            SWITCH
               Case tfld.a = fldx.a: down.r [f] = p   ; moved to match
                                     down.f = true
                                     QuitLoop
               Case fld.a = fldx.a:  down.f = true    ; didn't move from home
                                     QuitLoop
               Case fldx.a = fldy.a: QuitLoop         ; didn't move from move
               Otherwise:            UK_FldMatch ()
                                     IF RetVal THEN QuitLoop ENDIF
            ENDSWITCH
         ENDWHILE
      ENDIF

      MoveTo Field fld.a               ; move back to home base
      IF Not up.f THEN
         WHILE true
            fldy.a = Field ()
            Up                         ; move with key
            fldx.a = Field ()
            SWITCH
               Case tfld.a = fldx.a: up.r [f] = p   ; moved to match
                                     up.f = true
                                     QuitLoop
               Case fld.a = fldx.a:  up.f = true    ; didn't move from home
                                     QuitLoop
               Case fldx.a = fldy.a: QuitLoop       ; didn't move from move
               Otherwise:            UK_FldMatch ()
                                     IF RetVal THEN QuitLoop ENDIF
            ENDSWITCH
         ENDWHILE
      ENDIF

      IF right.f and left.f and down.f and up.f THEN
         QuitLoop
      ENDIF
   ENDFOR
ENDFOR

up.s = ""
down.s = ""
left.s = ""
right.s = ""
FOR x FROM 1 TO fmax.n
   up.s    = up.s    + Chr (up.r [x] + 64)
   down.s  = down.s  + Chr (down.r [x] + 64)
   left.s  = left.s  + Chr (left.r [x] + 64)
   right.s = right.s + Chr (right.r [x] + 64)
ENDFOR

ENDPROC
;======

;===
PROC UK_FldMatch ()
    ;==============
Private x, ok.f

ok.f = false
FOR x FROM 1 to fmax.n
   IF fldx.a = fld.r [x] THEN
      ok.f = true
      QuitLoop
   ENDIF
ENDFOR
IF ok.f THEN
   Return true
ELSE
   Return false
ENDIF

ENDPROC
;======

;===
PROC UK_SaveV ()
    ;===========
Private prnchar.a, x

@ 14,20 ?? "Saving Variables in a Script"
ClearAll
IF IsFile ("savevars.sc") THEN
   {Tools} {Delete} {Script} {Savevars} {OK}
ENDIF

pw1a.a = "EDIT MODE  "
pw1b.a = "VIEW MODE  "
pw2a.a = "Display Only "
pw3a.a = "Master "
pw3b.a = "Embedded "
pw4a.a = "Unit Form "
pw4b.a = "MultiRecord "
pw5a.a = "Key Link 1-Many "
pw5b.a = "Key Link 1-1 "
pw5c.a = "Field Linked "
pw5d.a = "Unlinked "
pw6a.a = " No-Record-Scroll  Alt-H:Help"
pw6b.a = " Record-Scroll-OK  Alt-H:Help"
pw7a.a = "Ctrl-U:UnDo  F8:Clear/Delete  F2:OK/File"
pw7b.a = "F5:Set-View-Mode  F10:End-Job"
pw7c.a = "F8:Delete  F9:Change-Record  Alt-F9:Enter-New-Record  F10:End-Job"
pw8a.a = "  F1:LookupHelp"
ph1.a =
"Move to Desired Record with Up/Dn, PgUp/Dn, CtrlPgUp/Dn, or Zoom on Any Field"
ph2.a =
"Press F2 to Select Entry or Esc to Return to Entry Screen without Selection"

Array p.r [8]                  ; initialize blank promts
FOR x FROM 1 TO 8
   p.r [x] = Spaces (40)
ENDFOR
pmt1.a = Spaces (80)
pmt2.a = Spaces (80)
save.x = Spaces (40)
msg.a  = Spaces (60)

edit.f  = false
quit.f  = false
a1.f    = false
disp.f  = false
new.f   = false
linkg.f = false
linkm.f = false
linko.f = false
linku.f = false
mastl.f = false
mastx.f = false
mult.f  = false
mrec.f  = false

mask.a = mask.r [1]
pkeys.n = tkeys.n
grp.n = 1
grp_n = 1
pos.n = 1
pos_n = 1

SaveVars
         fmax.n, fld.r,
         rqd.s, pstp.s, prep.s, tab.s, path.s, group.s, luh.s,
         right.s, left.s, down.s, up.s, mask.s, mask.r, mask.a,
         pmax.n, path.r, pmin.r, pmax.r, px34.r, plink.s,
         pkeys.n, tkeys.n, path.a, path_a,
         tablnam.a, pathnam.a, form.a,
         gmax.n, gmax.r, gmin.r,
         pos.n, pos_n, grp.n, grp_n,
         pw1a.a, pw1b.a, pw2a.a, pw3a.a, pw3b.a,
         pw4a.a, pw4b.a, pw5a.a, pw5b.a, pw5c.a, pw5d.a,
         pw6a.a, pw6b.a, pw6c.a, pw6d.a,
         pw7a.a, pw7b.a, pw7c.a, pw8a.a, ph1.a, ph2.a,
         pmt1.a, pmt2.a, p.r,
         linkg.f, linkm.f, linko.f, linku.f, mastl.f, mastx.f, mult.f,
         msg.a, save.x, a1.f, disp.f, kctrl.f, autoe.f, quit.f, new.f

outsc.a = descctrl.r [5] + descctrl.r [9] + "_v"
IF IsFile (outsc.a + ".sc") THEN
   {Tools} {Delete} {Script} Select outsc.a {OK}
ENDIF
{Tools} {Rename} {Script} {savevars} Select outsc.a

@ 16,20 ?? "Cleaning up Tables and Printing Report"
Delete "tscan"

ENDPROC
;======
